package be.iminds.ilabt.jfed.util.debug_info;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Service;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedConnection;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUser;
import be.iminds.ilabt.jfed.util.library.KeyUtil;
import org.slf4j.LoggerFactory;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class DebugInfoFactory {
    private static final org.slf4j.Logger LOG = LoggerFactory.getLogger(DebugInfoFactory.class);

    @Nonnull
    public static JFedConnection.DebugInfo createFromService(@Nullable GeniUser user, @Nullable Service service) {
        Server server = service == null ? null : service.getServer();
        if (server == null && service != null)
            LOG.warn("DebugInfoFactory.createFromService called with Service with Server == null " +
                    "(this is best avoided, or some debug info will be missing)");

        return new JFedConnection.DebugInfo(
                user == null ? null : user.getUserUrnString(),
                user == null ? null : KeyUtil.x509certificateChainToPem(user.getClientCertificateChain()),

                service == null ? null : service.getId(),
                service == null ? null : service.getServerId(),
                server == null ? null : server.getName(),
                server == null ? null : server.getDefaultComponentManagerUrn(),
                server == null ? null : server.getTestbedId(),
                server == null ? null : server.hasFlag(Server.Flag.workaroundMustReconnectEachCall)
        );
    }
}
